include CopyData.inc
;**********************CODE SEGMENT*********************************
.code 

start:;START PROG HERE. 
		invoke	InitCommonControls
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax
		invoke	DialogBoxParam,hInstance,IDD_COPYDATA ,NULL,offset DlgProc,0
		invoke	ExitProcess,NULL

;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
local hwndEdit:dword
local hwndT:dword
local cds:COPYDATASTRUCT
local pTempHeap:dword
		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		.elseif	eax == WM_INITDIALOG
			invoke LoadIcon,hInstance,IDI_COPYDATA 
			push eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax		
			pop eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
			; Initialize the edit controls with some test data.
			dsText InitData1,"Some test data"
			dsText InitData2,"Some more test data"
			invoke SetDlgItemText,hWnd,IDC_DATA1,addr InitData1
			invoke SetDlgItemText,hWnd,IDC_DATA2,addr InitData2
		.elseif eax==WM_COPYDATA
			mov eax,lParam
			assume eax:ptr COPYDATASTRUCT
			invoke SetDlgItemText,hWnd,[eax].dwData,[eax].lpData
			assume eax:nothing
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			.if eax == IDCANCEL
				invoke	EndDialog,hWnd,NULL
			.elseif eax==IDC_COPYDATA1 || eax==IDC_COPYDATA2
				.if eax==IDC_COPYDATA1
					mov eax,IDC_DATA1
				.else
					mov eax,IDC_DATA2
				.endif
				; Prepare the COPYDATASTRUCT.
				;Indicate which data field we're sending with their id
				mov cds.dwData,eax
				;Get the length (in bytes) of the data block we're sending.
				invoke GetDlgItem,hWnd,eax
				mov hwndEdit,eax
				invoke GetWindowTextLength,eax
				inc eax				
				mov cds.cbData,eax
				; Allocate a block of memory to hold the string.
				invoke GetProcessHeap
				invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,cds.cbData
				mov pTempHeap,eax
				mov cds.lpData,eax
				;Put the edit control's string in the data block.
				invoke GetWindowText,hwndEdit,eax,cds.cbData
				;Get the caption of our window.
				invoke GetWindowText,hWnd,addr szCaption,MAXSIZE
				;Enumerate through all the top-level windows with the same caption
				mov hwndT,NULL;To avoid error,We Must make it be NULL before recycle!!!
				.while TRUE
					invoke FindWindowEx,NULL,hwndT,NULL,addr szCaption
					.break .if eax==NULL
					mov hwndT,eax
					invoke SendMessage,hwndT,WM_COPYDATA,hWnd,addr cds
				.endw
				invoke GetProcessHeap
				invoke HeapFree,eax,NULL,pTempHeap
			.endif
		.else
			mov	eax,FALSE
			ret
		.endif		   
		mov	eax,TRUE
		ret
DlgProc	endp
;********************************************************************

end	start
